function [c,cinv,o,pipruh,mstar,hatC,plevel]=HL_test(X,Y,b0,beta,g);

% c... teoreticke cetnosti v jednotl. decilech
% cinv... teoreticke cetnosti nul v jednotl. decilech
% o... empiricke cetnosti v jednotl. decilech
% pipruh... odhady P(Y=1|X\in decil)
% hatC... testova statistika
% plevel.. dosazena hladina testu
% mstar... pocty pozorovani v jedn. percentilech

% g... pocet sloupcu nove kont. tabulky

% predpoklad: zadne dva radky X nejsou stejne

n=size(X,1);
p=size(X,2);

celecis=floor(n/g);
zbytek=mod(n,g);

% urceni poctu pozorovani v jednotlivych sloupcich
% nekolik prvnich sloupcu bude o jedno pozorovani bohatsi
% (je-li to nutne)

for i=1:zbytek
   mstar(i)=celecis+1;
end;
for i=(zbytek+1):g
   mstar(i)=celecis;
end;   
   

for i=1:n
   pi(i)=(1+exp(-b0-X(i,:)*beta))^(-1);
end;

pi=pi';      % sloupcovy vektor

Z1=[X,Y,pi];
Z=sortrows(Z1,p+2);   % setrideni pozorovani podle pi

% 1. urceni teoretickych cetnosti v jednotl. sloupcich
% 2. urceni empirickych cetnosti v jednotl. sloupcich
% 3. urceni odhadu prsti P(Y=1|X\in decil)

zacatek=1;
for i=1:g
   c(i)=sum(Z(zacatek:(zacatek+mstar(i)-1),(p+2)));
   cinv(i)=mstar(i)-c(i);
   o(i)=sum(Z(zacatek:(zacatek+mstar(i)-1),(p+1)));
   pipruh(i)=c(i)/mstar(i);
   zacatek=zacatek+mstar(i);
end;

% vypocet testove statistiky

soucet=0;
for i=1:g
   soucet=soucet+(((o(i)-c(i))^2)/(c(i)*(1-pipruh(i))));
end;

hatC=soucet;
plevel=1-chi2cdf(hatC,(g-2));